/***************************************************************************
                          wepdlg.cpp  -  description
                             -------------------
    begin                : Tue Jun 27 2000
    copyright            : (C) 2000 by Jae-Jun Lee
    email                : brucejr@samsung.co.kr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "wepdlg.h"
#include "swlioctl.h"
#include "iwcommon.h"

wepDlg::wepDlg(QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();
}

wepDlg::~wepDlg(){
}

void wepDlg::setDialogWindows(char* name,int skfd1){
   struct iwreq wrq;
   char buf[256],*bp;
   QString strTemp;

   bp = buf;

   strcpy(ifname,name); //adaptr name,eth0...
   skfd = skfd1;        //socket pointer.
   strcpy(wrq.ifr_name,ifname);

   //get default wep key ID(SWL_UIL_WEPKEYID_GET).
   //WEP
   wrq.u.data.pointer = (caddr_t)buf;
   wrq.u.data.length = 1;
   wrq.u.data.flags = SWL_UIL_WEPKEYID_GET;
   if(ioctl(skfd,SIOCDEVPRIVATE , &wrq) < 0)
    {
       debug("There is a problem while reading WEP Default Key ID ...\n");
       defaultKeyID->setCurrentItem(0);
     }
   else{
       defaultKeyID->setCurrentItem(buf[0]);
   }
   strcpy(wrq.ifr_name,ifname);
   setCaption("WEP KEY Setup");
   QObject::connect(OKButton,SIGNAL(clicked()),this,SLOT(OnOK()));
   QObject::connect(CancelButton,SIGNAL(clicked()),this,SLOT(reject()));

}/**  */
void wepDlg::OnOK(){
   struct iwreq wrq;
   char buf[256],*bp;
   const char constBuf[10],*c_bp;
   int temp;
   QString strTemp;

   bp = buf;
   c_bp = constBuf;
   strcpy(wrq.ifr_name, ifname);

   //WEP KEY
   strTemp = Key1->text();
   strcpy(buf,strTemp);
   debug("key1=%s\n",buf);
   wrq.u.data.pointer = (caddr_t)buf;
   wrq.u.data.length = strlen(buf);
   wrq.u.data.flags = SWL_UIL_WEPKEY1;
   if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) < 0)
    {
       debug("There is a problem while setting WEP KEY 1\n");
    }
   strTemp = Key2->text();
   strcpy(buf,strTemp);
   debug("key2=%s\n",buf);
   wrq.u.data.pointer = (caddr_t)buf;
   wrq.u.data.length = strlen(buf);
   wrq.u.data.flags = SWL_UIL_WEPKEY2;
   if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) < 0)
    {
       debug("There is a problem while setting WEP KEY 2\n");
    }
    strTemp = Key3->text();
   strcpy(buf,strTemp);
   debug("key3=%s\n",buf);
   wrq.u.data.pointer = (caddr_t)buf;
   wrq.u.data.length = strlen(buf);
   wrq.u.data.flags = SWL_UIL_WEPKEY3;
   if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) < 0)
    {
       debug("There is a problem while setting WEP KEY 3\n");
    }
   strTemp = Key4->text();
   strcpy(buf,strTemp);
   debug("key4=%s\n",buf);
   wrq.u.data.pointer = (caddr_t)buf;
   wrq.u.data.length = strlen(buf);
   wrq.u.data.flags = SWL_UIL_WEPKEY4;
   if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) < 0)
    {
       debug("There is a problem while setting WEP KEY 4\n");
    }
   //Default WEP KEY ID.
    buf[0] = defaultKeyID->currentItem();
    wrq.u.data.pointer = (caddr_t)buf;
    wrq.u.data.length = 1;
    wrq.u.data.flags = SWL_UIL_WEPKEYID_SET;
    if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) < 0)
    {
      debug("There is a problem while seting WEP Default Key ID\n");
    }
    //software reset.
   wrq.u.data.pointer = (caddr_t)buf;
   wrq.u.data.length = 1;
   wrq.u.data.flags = SWL_UIL_SOFTRESET;
   if(ioctl(skfd,SIOCDEVPRIVATE, &wrq) < 0)
    {
       debug("There is a problem while SOFT RESET\n");
    }

  QDialog::accept();
}
